datablock AudioProfile(RagingBullFireSound)
{
   filename    = "./fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RagingBullFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RagingBullFire3Sound)
{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RagingBullclipInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RagingBullclipOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RagingBullUseSound)
{
   filename    = "./wpn_hudoff.wav";
   description = AudioClose3d;
   preload = true;
};

//Effects
//Flash
datablock ParticleData(RagingBullflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./M45Flash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RagingBullflashEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RagingBullflashParticle";

   uiName = "Raging Bull Flash";
};

//POOF Sparks
datablock ParticleData(RagingBullExplosionChunkParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 2400;
   lifetimeVarianceMS   = 1300;
   textureName          = "./muzzleSpark";
   spinSpeed		= 5.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "1 1 1 1";
   colors[1]     = "0.6 0.6 0.6 0.2";
   sizes[0]      = 0.05;
   sizes[1]      = 0;
   times[0]		= 0;
   times[1]		= 1;
 
   useInvAlpha = true;
};
datablock ParticleEmitterData(RagingBullExplosionChunkEmitter)
{
   lifeTimeMS = 25;

   ejectionPeriodMS = 50;
   periodVarianceMS = 10;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RagingBullExplosionChunkParticle";
};

datablock DebrisData(RagingBullDebris)
{
   emitters = "RagingBullExplosionChunkEmitter";

	shapeFile = "./muzzleSpark.dts";
	lifetime = 2.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 400.0;
	elasticity = 0.5;
	friction = 0.05;
	numBounces = 5;
	staticOnMaxBounce = false;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(RagingBullMuzzleExplosion)
{

   debris = RagingBullDebris;
   debrisNum = 10;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 10;
   debrisVelocityVariance = 10;
   lifeTimeMS = 250;

   //particleEmitter = RagingBullExplosionChunkEmitter;
   //particleDensity = 5;
   //particleRadius = 0.2;
   
   //emitter[0] = RagingBullExplosionChunkEmitter;
   //emitter[1] = RagingBullExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "5.0 6.0 5.0";
   camShakeAmp = "2.0 6.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 3.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 1;
   lightStartColor = "0.5 0.5 0 1";
   lightEndColor = "0.3 0.1 0.0 1";

   damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 0;
   impulseForce = 0;
};



AddDamageType("RagingBull",   '<bitmap:add-ons/Weapon_RagingBull/CI_RagingBull> %1',    '%2 <bitmap:add-ons/Weapon_RagingBull/CI_RagingBull> %1',0.2,1);
datablock ProjectileData(RagingBullProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 44;
   directDamageType    = $DamageType::RagingBull;
   radiusDamageType    = $DamageType::RagingBull;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 2;
   brickExplosionMaxVolume = 2;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 4;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "Raging Bull Bullet";
};

datablock ProjectileData(RagingBullMuzzleExplosionProjectile)
{
   projectileShapeName = "./empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::RagingBull;
   radiusDamageType    = $DamageType::RagingBull;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = RagingBullMuzzleExplosion;

   muzzleVelocity      = 0;
   velInheritFactor    = 1;
   explodeOnDeath = true;

   armingDelay         = 00;
   lifetime            = 0;
   fadeDelay           = 0;
   bounceElasticity    = 5;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "Raging Bull Muzzle Explosion Projectile";
};

//////////
// item //
//////////
datablock ItemData(RagingBullItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./RagingBull_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Taurus Raging Bull";
	iconName = "./UI_RagingBull";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = RagingBullImage;
	canDrop = true;

	maxAmmo = 8;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RagingBullImage)
{
   // Basic Item properties
   shapeFile = "./RagingBull.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.35 0.9 -0.25"; //"0.5 1.3 -0.3"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = RagingBullItem;
   ammo = " ";
   projectile = RagingBullProjectile;
   projectileType = Projectile;

	casing = RagingBullCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = RagingBullItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.53;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= RagingBullUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.55;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  	= false;
	stateEmitter[2]				= RagingBullFlashEmitter;
	stateEmitterTime[2]			= 0.01;
	stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]				= RagingBullFireSound;

	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.0001;
	stateEmitter[7]				= gunSmokeEmitter;
	stateEmitterTime[7]			= 0.0001;
	stateEmitterNode[7]			= "muzzleNode";
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready";
	stateTransitionOnNoAmmo[9]		= "Reload";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 1.07;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= RagingBullclipOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 1.25;
	stateSound[11]				= RagingBullclipInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateEmitter[14]			= gunSmokeEmitter;
	stateEmitterTime[14]			= 0.0001;
	stateEmitterNode[14]			= "muzzleNode";
	stateTimeoutValue[14]			= 0.0001;
	stateTransitionOnTimeout[14]		= "Ready";
	stateTransitionOnTriggerDown[14]	= "Fire";
	
	stateName[15] 				= "ReloadSmoke";
	stateEmitter[15]			= gunSmokeEmitter;
	stateEmitterTime[15]			= 0.0001;
	stateEmitterNode[15]			= "muzzleNode";
	stateTimeoutValue[15]			= 0.0001;
	stateTransitionOnTimeout[15]		= "Reload";
	
	stateName[16]				= "Reloaded";
	stateTimeoutValue[16]			= 0.01;
	stateScript[16]				= "onReloaded";
	stateTransitionOnTimeout[16]		= "Ready";
	
	
};

function RagingBullImage::onFire(%this,%obj,%slot)
{

%pos = %obj.getTransform();
   %random = getRandom(1,3);
   switch(%random)
   {
      case 1:
         serverplay3d(RagingBullFireSound,%pos);
      case 2:
         serverplay3d(RagingBullFire2Sound,%pos);
      case 3:
         serverplay3d(RagingBullFire3Sound,%pos);
      default:
         echo("Error on Raging Bull");
   }
   
   
	%projectile = RagingBullProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.00005;
	}
	else
	{
		%spread = 0.001;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	//%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	
	%projectile = "RagingBullMuzzleExplosionProjectile";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}


function RagingBullImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function RagingBullImage::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

function RagingBullImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 8;
	%obj.setImageAmmo(%slot,1);
}


function RagingBullImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function RagingBullImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}
